#include "parallel.h"

void linear_system(Dlu_info *Info, Cvector *b, Cvector *x, Extra *extra)
{
   char *Subroutine_name = "linear_system():";
   int  *Matrix_Rank = &(Info->rank);
   int   Matrix_Size = Info->Matrix->M;

   if(!(Info -> fact_mode))
   {
#ifdef LU_DEBUG
      print("linear_system(): calling 'A' mode");
#endif
      lu_factor_Dmatrix_a(Info, NULL, b);
      Info -> fact_mode = 1;
   }
   else
   {
      /* if(Info -> fact_mode == 1) */
#ifdef LU_DEBUG
      print("lu_factor_Dmatrix(): calling 'B' mode");
#endif
      lu_factor_Dmatrix_b(Info, NULL, b);
   }


   if (*Matrix_Rank < Matrix_Size)
   {

      /*
       * this condition will appear in all proc. columns so no recursive
       * doubling is required...
       */

      print("%s Jacobian rank deficient with rank %d < %d",
            Subroutine_name, *Matrix_Rank, Matrix_Size);
      exit(1);
   }

#ifdef LU_DEBUG
   print("linear_system() exiting");
#endif
}

